'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/*
 * Класс вспомогательных методов работы с массивами
 *
 * - getChecked - получить объект из массива с выбранным параметром isChecked=true
 * - get
 * - getDeep
 * */
var ArrayHelper = function () {
    function ArrayHelper() {
        _classCallCheck(this, ArrayHelper);
    }

    _createClass(ArrayHelper, null, [{
        key: 'getChecked',


        // получить 1 выбранный объект из массива (с первым isChecked=true)
        value: function getChecked(array) {
            var newObject = {};
            var length = array.length;

            if (length > 0) {
                for (var i = 0; i < length; i++) {
                    if (array[i].isChecked == true) {
                        newObject = array[i];
                        break;
                    }
                }
            }

            return newObject;
        }

        /**
         * Получить 1 элемент по паре {ключ : значение}
         * или по нескольким парам
         *
         * flags = {}
         * - getI : true - вернёт только номер объекта в массиве
         * - getI : all - вернет объект {item : {}, i : 0}
         * @searchObj {key : value} или {key : value1, key2 : value2...}
         * @return object or null (если было получение ключа, то -1 или число от 0 и выше)
         * */

    }, {
        key: 'get',
        value: function get(array, searchObj, flags) {
            if (flags == undefined) flags = {};

            if (array) {
                var meLength = array.length;
                var item;
                var isIt = true;

                if (searchObj) {
                    if (meLength > 0) {
                        var _i = -1;
                        for (var i = 0; i < meLength; i++) {
                            item = array[i];
                            //сразу выставляем, что элемент объекта подходит по критерию,
                            // и пробуем в цикле опровергнуть это утверждение
                            isIt = true;

                            for (var key in searchObj) {
                                if (item[key] || item[key] === 0) {
                                    if (searchObj[key] instanceof Object) {
                                        c('Для глубокой проверки используйте getDeep()');
                                        isIt = false;
                                    } else {
                                        if (item[key] == searchObj[key]) {} else {
                                            isIt = false;
                                            break;
                                        }
                                    }
                                }
                                //false будет почти всегда, за исключением того самого элемента
                                else {
                                        isIt = false;
                                        break;
                                    }
                            }

                            if (isIt == true) {
                                _i = i;
                                break;
                            }
                        }

                        if (isIt == true) {
                            if (flags.getI == true) {
                                return _i;
                            } else if (flags.getI == "all") {
                                return {
                                    item: array[_i],
                                    i: _i
                                };
                            } else {
                                return array[_i];
                            }
                        }
                    }
                }
            }
            if (flags.getI == true) {
                return -1;
            } else {
                return null;
            }
        }

        /**
         * Получить 1 элемент из проверяемого массива по куску проверочного массива
         * flags = {}
         * - getI : true - вернёт только номер объекта в массиве
         * - getI : all - вернет объект {item : {}, i : 0}
         *
         * @searchObj {key1 : {key2 : value2}}
         * @return object or null
         */

    }, {
        key: 'getDeep',
        value: function getDeep(array, searchObj, flags) {
            if (flags == undefined) flags = {};

            if (array) {
                var meLength = array.length;
                var item;
                var value2;
                var isIt = true;

                if (searchObj) {
                    if (meLength > 0) {
                        var _i = -1;
                        for (var i = 0; i < meLength; i++) {
                            item = array[i];
                            //сразу выставляем, что элемент объекта подходит по критерию,
                            // и пробуем в цикле опровергнуть это утверждение
                            isIt = true;

                            for (var key1 in searchObj) {
                                if (item[key1]) {
                                    if (!(searchObj[key1] instanceof Object)) {
                                        c('Для простой проверки используйте get()');
                                        isIt = false;
                                    } else {
                                        for (var key2 in searchObj[key1]) {
                                            if (item[key1][key2] == searchObj[key1][key2]) {} else {
                                                isIt = false;
                                                break;
                                            }
                                        }
                                    }
                                } else {
                                    isIt = false;
                                    break;
                                }
                            }

                            if (isIt == true) {
                                _i = i;
                                break;
                            }
                        }

                        if (isIt == true) {
                            if (flags.getI == true) {
                                return _i;
                            } else if (flags.getI == "all") {
                                return {
                                    item: array[_i],
                                    i: _i
                                };
                            } else {
                                return array[_i];
                            }
                        }
                    }
                }
            }

            return null;
        }
    }]);

    return ArrayHelper;
}();

exports.default = ArrayHelper;